;===============================================================
; 2.0
; - PIC16F873A
; .. 4 
;   1.0k
;  ..
;****************************************************************
	#include "P16F873A.INC"               ; .  . 
	LIST    p=16F873A  	; 

   __CONFIG     B'01100000110001' ;

   ERRORLEVEL      -302                ;  302   
   ERRORLEVEL      -306                ;  306  
   ERRORLEVEL      -202                ;  202  
   ERRORLEVEL      -203                ;  203  
   ERRORLEVEL      -206                ;  206  
;*********************************************************
;  
;    PORTA,0         ; . ( )
;    PORTA,1         ; . ( )
;    PORTA,2          ; . (START/STOP)
;    PORTA,3         ;
;    PORTA,4         ; 
;    PORTA,5         ;   .

;    PORTB,0         ;  
;    PORTB,1         ;Clock (LMX2316)
;    PORTB,2         ;Data (LMX2316)
;    PORTB,3         ;LE (LMX2316)
;    PORTB,4         ;LCD-D4
;    PORTB,5         ;LCD-D5
;    PORTB,6         ;LCD-D6
;    PORTB,7         ;LCD-D7

;    PORTC,0         ; 0 ()
;    PORTC,1         ; 1 ()
;    PORTC,2         ; 2 ()
;    PORTC,3         ; 
;    PORTC,4         ;
;    PORTC,5         ;  TTL
;    PORTC,6         ;LCD-R
;    PORTC,7         ;LCD-E ()
;*****************************************************************************
;  
R_T   EQU 20h   ; 
R_TIMER   EQU 21h   ; 
R_Cont   EQU 22h   ;   
R_RANG   EQU 23h   ; 
R_IN   EQU 24h   ; 
R_TL   EQU 25h   ; 
R_TH   EQU 26h   ; 
REG_D   EQU 27h   ; 
REG_SL   EQU 28h   ;  

cblock   0x40
LED0	;  
LED1
LED2
LED3
LED4
LED5
LED6
LED7
LED8
Temp       ; 
LEDtemp  	; LED
Count		; 
Count2		; 
TimerL		;   
TimerM		;   
TimerH		;   
TimerHH		;    
IFL		;  
IFM		; 
IFH	
IFHH 
RL_F
RM_F
RH_F
RHH_F
R_VHF_L      ; 
R_VHF_H      ; 
R_UHF_L     ; 
R_UHF_H     ; 
temp_DL     ;
temp_DM     ;
temp_DH     ;
temp_DHH    ;
REG_FL      ; 
REG_FM      ; 
REG_FH      ; 
REG_FHH      ; 
REG_dFL      ;  
REG_dFM      ;  
REG_dFH      ;  
REG__dFL      ;  
REG__dFM      ;  
REG__dFH      ;  
REG__FL     ;  
REG__FM      ;  
TEMP_L               ;
TEMP_M              ;
TEMP_H             ;
TEMP_HH               ;

R_EEADR 	
R_EEDATA
	
W_TEMP               ;
STATUS_TEMP               ;
F_TEMP               ;
 endc
;******************************************************************************
;  PORTA 
RA7          EQU    07H
RA6          EQU    06H
RA5          EQU    05H
RA4          EQU    04H
RA3          EQU    03H
RA2          EQU    02H
RA1          EQU    01H
RA0          EQU    00H
;***************************************************************
;  PORTB 
RB7          EQU    07H
RB6          EQU    06H
RB5          EQU    05H
RB4          EQU    04H
RB3          EQU    03H
RB2          EQU    02H
RB1          EQU    01H
RB0          EQU    00H
;***************************************************************
;  PORTC 
RC7          EQU    07H
RC6          EQU    06H
RC5          EQU    05H
RC4          EQU    04H
RC3          EQU    03H
RC2          EQU    02H
RC1          EQU    01H
RC0          EQU    00H
;=============================================
;=============================================
BUTT_RA0:          macro        ; 
       CALL     _T30mS            ;
       BTFSS    PORTA,RA0           ;
      goto       T_Metr
        endm
;=============================================
BUTT_RA1:          macro        ; 
       CALL     _T30mS            ;
       BTFSS    PORTA,RA1           ;
      goto       IN_Metr
        endm;
;=============================================
;=============================================
        ORG        00H            ;   .
        GOTO    _INIT              ;  
        ORG        04H            ;

       MOVWF      W_TEMP              ;
     MOVF    STATUS,W           ;
       MOVWF      STATUS_TEMP              ;
	MOVFW	FSR		;FSR.
	MOVWF	F_TEMP		;


       BTFSS  REG_SL,1            ;
       GOTO    _GIE              ;
nop
nop
     BCF      INTCON,4        ; -OFF
     CLRF  T1CON           ;TMR1-OFF
        RETFIE                    ;
_GIE                           ;

nop
nop

       BCF    INTCON,T0IF           ;
       INCF    TimerH,F         ;
       BTFSS  STATUS,Z             ;
        RETFIE                    ;
       INCF    TimerHH,F         ;


     MOVF    STATUS_TEMP,W           ;
       MOVWF      STATUS              ;
	MOVFW	F_TEMP		;
	MOVWF	FSR		;FSR,
     MOVF    W_TEMP,W           ;

        RETFIE                    ;
;*******************************************************     
;  
;***********************************************************
_INIT                              ; . 
        BSF     STATUS,RP0         ;  2-  
       MOVLW   B'00111111'        ; PORTA:RA0-RA5,7- ,
       MOVWF   TRISA              ;  
       MOVLW   B'00000001'        ; PORT:0,4,5- ,. 
       MOVWF   TRISB              ;  TRISB
  MOVLW   B'00100000'        ; PORTC:. 
       MOVWF   TRISC              ;  TRISC
       MOVLW   B'10000111'        ;  OPTION (=256)
       MOVWF   OPTION_REG         ;

 CLRF	PIE2^80H	;CCP2 .
 MOVLW	0x07		;   "" .
 MOVWF	ADCON1		;

        BCF     STATUS,RP0         ;  1-  

 BCF	T1CON,0		;.
 CLRF	SSPCON		;
 CLRF	RCSTA		;USART .
 CLRF	T2CON		; 2 .

        CLRF   INTCON         ;
        CLRF   PORTB              ;
        CLRF   PORTC              ;
        CALL    AD_OFF               ;
     CLRF   REG_SL        ;
        CALL   INIT                ;
    CALL    READ_K             ;   
    CALL    READ_U             ;   
        CALL   INIT_GKI                ;


;**************************************************************
;
;**************************************************************
Test                         ;
     BTFSC    PORTA,RA2           ;
       GOTO   _Start                 ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;

	movlw	b'10000101'	;   
	call	LEDcom		;
	movlw	24h	                  ;T
	call	LEDdata
	movlw	15h	               ;E
	call	LEDdata
   	movlw	23h	             ;   S
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata

        BSF     STATUS,RP0         ;  2-  
       BCF   TRISC,5              ;  TRISC
        BCF     STATUS,RP0         ;  1-  

Test1                         ;
        BSF     PORTC,5         ;
NOP
NOP
NOP
NOP
        BCF     PORTC,5         ;
NOP
NOP
       GOTO   Test1                 ;
;**************************************************************
_Start                          ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
	movlw	b'10000001'	;   
   CALL     F__DEL                ;
      movlw	 50h	         ;
      call	LEDdata                 ;
    movlw	1Dh	                 ;M
	call	LEDdata
	movlw	15h	               ;E
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	15h	               ;E
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
       CALL    _T2S               ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
       GOTO    F_IZM              ;
;**************************************************************
;  ********************************************
T_Metr                               ;
       CLRF    R_TIMER              ;
T_Metr1                               ;
       BTFSC   INTCON,2           ;
       CALL     __T                ;
       BTFSC   R_TIMER,5         ;   
       GOTO   F_IZM                 ;
       BTFSC    PORTA,RA0           ;
       GOTO   T_Metr1                 ;
       CALL     _T30mS            ;
       BTFSC    PORTA,RA0           ;
       GOTO   T_Metr1                 ;
       	movlw	b'00000001'       	; 
    	call	LEDcom               ;
    BCF     STATUS,C         ;
    RLF    R_RANG,F            ;
       CLRF    R_TIMER              ;
       BTFSS  R_RANG,6            ;
       GOTO   T__Metr2                ;
       MOVLW   .1        ;
       MOVWF   R_RANG               ;
T__Metr2                               ;
     CALL   R_Metr                ;
T_Metr2                               ;
       BTFSS    PORTA,RA0           ;
       GOTO   T_Metr2                ;
       CALL     _T30mS            ;
       BTFSS    PORTA,RA0           ;
       GOTO   T_Metr2                ;
    CALL    ZAP_U             ;
       GOTO    T_Metr1                 ;
;   -***************************************************************
R_Metr
	movlw	b'10001101'	;   
	call	LEDcom		;
       BTFSS  R_RANG,0            ;
       GOTO   R_Metr1                ;
	movlw	01h	                  ;1
	call	LEDdata
	movlw	00h	                  ;0
	call	LEDdata
       RETURN                     ;
R_Metr1                               ;
       BTFSS  R_RANG,1            ;
       GOTO   R_Metr2                ;
	movlw	01h	                  ;1
	call	LEDdata
R_Metr2                               ;
       BTFSS  R_RANG,2            ;
       GOTO   R_Metr3                ;
      CALL    ZAP_Y              ;
	movlw	01h	                  ;1
	call	LEDdata
R_Metr3                               ;
       BTFSS  R_RANG,3            ;
       GOTO   R_Metr4                ;
      CALL    ZAP_Y              ;
	movlw	00h	                  ;0
	call	LEDdata
	movlw	01h	                  ;1
	call	LEDdata
R_Metr4                               ;
       BTFSS  R_RANG,4            ;
       GOTO   R_Metr5                ;
    CALL     P_CNR                ;
       RETURN                     ;
R_Metr5                               ;
       BTFSS  R_RANG,5            ;
       RETURN                     ;
       CALL     F_DEL               ;   
       RETURN                     ;
;**************************************************************
;  ********************************************
IN_Metr                               ;
       CLRF    R_TIMER              ;
IN_Metr1                               ;
       BTFSC   INTCON,2           ;
       CALL     __T                ;
       BTFSC   R_TIMER,5         ;   
       GOTO   F_IZM                 ;
     BTFSC    PORTA,RA1           ;
       GOTO   IN_Metr1                 ;
       CALL     _T30mS            ;
     BTFSC    PORTA,RA1           ;
       GOTO   IN_Metr1                 ;
       	movlw	b'00000001'       	; 
    	call	LEDcom               ;
     BCF     STATUS,C         ;
     RLF    R_IN,F            ;
       CLRF    R_TIMER              ;
     BTFSC  R_IN,3            ;
       GOTO   IN__Metr1                ;
       BTFSS  R_RANG,4            ;
       GOTO   IN__Metr2                ;
       BTFSS  R_IN,2            ;
       GOTO   IN__Metr2                ;
IN__Metr1                               ;
       MOVLW   .1        ;
       MOVWF   R_IN               ;
IN__Metr2                               ;
       CALL   IN_UHF                ;
IN_Metr2                               ;
     BTFSS    PORTA,RA1           ;
       GOTO   IN_Metr2                ;
       CALL     _T30mS            ;
     BTFSS    PORTA,RA1           ;
       GOTO   IN_Metr2                ;
   CALL    ZAP_U             ;
       GOTO    IN_Metr1                 ;
;   -UHF...*************OK**************************************************
IN_UHF
	movlw	b'11001101'	;  
	call	LEDcom		;
       BTFSS  R_IN,0            ;
       GOTO   IN_UHF1                ;
     BCF   PORTC,RC0           ; 
     BCF   PORTC,RC1           ; 
             CALL    LATCHES                ;
       CALL     _TTL            ;
       RETURN                     ;
IN_UHF1                               ;
       BTFSS  R_IN,1            ;
       GOTO   IN_UHF2                ;
     BSF   PORTC,RC0           ; 
     BCF   PORTC,RC1           ; 
             CALL    LATCHES                ;
       CALL     _VHF            ;
    RETURN                     ;
IN_UHF2                               ;
       BTFSS  R_IN,2            ;
       RETURN                     ;
     BCF   PORTC,RC0           ; 
     BSF   PORTC,RC1           ; 
             CALL    LATCHES                ;
             CALL    N_Counter               ;
     CALL     _UHF            ;
   RETURN                     ;
;=============================================
ZAP_U                               ;
     MOVLW   .10        ;
     MOVWF   R_EEADR             ;
     MOVF    R_RANG,W           ;
     MOVWF   R_EEDATA             ;
     CALL    _ZAP            ;
     MOVLW   .11        ;
     MOVWF   R_EEADR             ;
     MOVF    R_IN,W           ;
     MOVWF   R_EEDATA             ;
     CALL    _ZAP            ;
       RETURN                     ;
;=============================================
READ_U                               ;
     MOVLW   .10        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_RANG             ;
     MOVLW   .11        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_IN             ;
       RETURN                  
;********************************************************
;  
;********************************************************
F_IZM                       ;
       BTFSC  R_RANG,4            ;
       GOTO   CNR_1                ;
       BTFSC  R_RANG,5            ;
       GOTO   DELTA_1                ;
    	movlw	b'00000001'       	; 
    	call	LEDcom               ;
     CALL   R_Metr                ;  
       CALL   IN_UHF                ; 
       CALL   F__M_r              ;   -F=

       BTFSS  R_IN,2            ;
        GOTO    F_IZM1              ;
   CALL    F_MIN               ;
           BTFSC   REG_SL,3            ;
        GOTO    F_IZM2              ;

F_IZM1                       ;
      CALL   INIT_1                ;
   BCF      REG_SL,1        ;
     BTFSC  R_RANG,0            ;
       CALL    F_10S             ;
     BTFSC  R_RANG,1            ;
       CALL    F_1S             ;
     BTFSC  R_RANG,2            ;
       CALL   F_100mS              ;
     BTFSC  R_RANG,3            ;
       CALL    F_10mS             ;
      CALL   INIT__F                 ;  TMR0
    CALL   Bin2LCD              ;

F_IZM2                       ;

BUTT_RA0
BUTT_RA1

      BTFSS    PORTA,RA2           ;
      GOTO    VHF_D              ;
        MOVF   LED5,0              ;
	    call	LEDdata            ;
        MOVF   LED4,0              ;
	    call	LEDdata            ;
     BTFSC  R_RANG,0            ;
      CALL    ZAP_Y              ;
        MOVF   LED3,0              ;
	    call	LEDdata            ;
     BTFSC  R_RANG,1            ;
      CALL    ZAP_Y              ;
        MOVF   LED2,0              ;
	    call	LEDdata            ;
     BTFSC  R_RANG,2            ;
      CALL    ZAP_Y              ;
        MOVF   LED1,0              ;
 	   call	LEDdata            ;
     BTFSC  R_RANG,3            ;
      CALL    ZAP_Y              ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
   	movlw	3Bh	           ;k
	call	LEDdata
     CALL   HZ_F              ;
   BTFSS  R_IN,2            ;
     GOTO   IZM_PULS              ;
	movlw	b'10001001'	;   
	call	LEDcom		;
     CALL   MHZ_F              ;
IZM_PULS                       ; 
     BTFSS  R_IN,0            ;
       GOTO   IZM_OUT              ;
        MOVF   LED5,F              ;  
       BTFSS  STATUS,Z            ;
        GOTO   IZM__PULS              ;
        MOVF   LED4,F              ;
       BTFSS  STATUS,Z            ;
        GOTO   IZM__PULS              ;
        MOVF   LED3,F              ;
       BTFSS  STATUS,Z            ;
        GOTO   IZM__PULS              ;
        MOVF   LED2,F              ;
       BTFSS  STATUS,Z            ;
        GOTO   IZM__PULS              ;
        MOVF   LED1,F              ;
       BTFSS  STATUS,Z            ;
        GOTO   IZM__PULS              ;
        MOVF   LED0,F              ;
       BTFSC  STATUS,Z            ;
        GOTO   IZM_OUT              ;
IZM__PULS                       ; 
       BSF      REG_SL,1        ;
     CALL   P__Metr               ; 
       CALL    _T1S               ;
BUTT_RA0
BUTT_RA1
      BTFSS    PORTA,RA2           ;
      GOTO    VHF_D              ;
     CALL   N__Metr               ; 
IZM_OUT                       ;
         CALL    _T1S               ;
         GOTO   F_IZM              ;
;******,    1250***************
F_MIN                           ;
       BCF      REG_SL,3        ;
       BTFSC  PORTC,RC5            ;
  CALL    N_Counter              ;  1000
     CALL   INIT_1                ;
     CALL    F_1mS              ;
       CALL   INIT__F              ;
       BTFSC  PORTC,RC5            ;
   CALL    N__Counter              ;
F_MIN1                           ;
     CALL   Bin2LCD              ;
             BCF    STATUS,C            ;
     MOVF   TimerM,W       ;
       SUBLW   .4             ;
        BTFSS  STATUS,C            ;
       GOTO    F_MIN2               ;
     BTFSS  STATUS,Z            ;
       RETURN             ;
     MOVF   TimerL,W           ;
       SUBLW   .226                ;
        BTFSC  STATUS,C            ;
       RETURN             ;
F_MIN2                           ;
       BSF      REG_SL,3        ;
      CLRF     TimerL          ;
        CLRF     TimerM          ;
        CLRF     TimerH          ;
        CLRF     TimerHH          ;
        CLRF     LED0          ;
        CLRF     LED1          ;
        CLRF     LED2          ;
        CLRF     LED3          ;
        CLRF     LED4          ;
        CLRF     LED5          ;
       RETURN             ;
;******************************************************
;***************************************************************
P__Metr                               ;
      CALL   P_Metr              ;   
        BSF     STATUS,RP0         ;  2-  
        MOVLW   B'11000000'        ;  
        MOVWF   OPTION_REG         ;
        BCF     STATUS,RP0         ;  1-  
    CLRF    INTCON         ;
    BSF      INTCON,4        ;
        MOVLW   B'00000100'        ;TMR1-OFF,FOSC/4,OSC-OFF,K=1
        MOVWF   T1CON             ;
      CLRF  TMR1L                ;
      CLRF  TMR1H                ;
      CLRF  REG_D           ;
        CLRF    PIR1           ;
P_Metr1                             ;


       BTFSS    PORTA,RA0           ; 
       RETURN                     ;


        BTFSS   INTCON,INTF            ;
        GOTO     P_Metr1                ;
        BCF      INTCON,INTF        ;
        BSF     STATUS,RP0         ;  2-  
        BCF    OPTION_REG,6          ;   
        BCF     STATUS,RP0         ;  1-  
     BSF     T1CON,0         ;TMR1-ON
     BSF      INTCON,GIE        ; 
P_Metr2                             ;


       BTFSS    PORTA,RA0           ; 
       RETURN                     ;


       BTFSC   INTCON,INTF            ;
       GOTO    P_Metr3                 ;
       BTFSS   PIR1,TMR1IF            ;  -OFF
       GOTO     P_Metr2                ;
       INCF    REG_D,F               ;
       BCF     PIR1,TMR1IF         ;
       GOTO     P_Metr2                ;
P_Metr3                             ;
       CALL   INIT__F              ;
     CALL  INDIK_Metr               ;
     CALL   Bin2LCD              ;   .. 
     CALL   IND_IMP              ;
     CALL   _uS              ;
        RETURN                     ;
;**************************************************************  
N__Metr                               ;
      CALL   N_Metr              ;   
        BSF     STATUS,RP0         ;  2-  
        MOVLW   B'10000000'        ;   
        MOVWF   OPTION_REG         ;
        BCF     STATUS,RP0         ;  1-  
    CLRF    INTCON         ;
    BSF      INTCON,4        ;
        MOVLW   B'00000100'        ;TMR1-OFF,FOSC/4,OSC-OFF,K=1
      CLRF  TMR1L                ;
      CLRF  TMR1H                ;
      CLRF  REG_D           ;
        CLRF    PIR1           ;
N_Metr1                             ;


       BTFSS    PORTA,RA0           ; 
       RETURN                     ;


        BTFSS   INTCON,INTF            ;
        GOTO     N_Metr1                ;
        BCF      INTCON,INTF        ;
        BSF     STATUS,RP0         ;  2-  
        BsF    OPTION_REG,6          ;   
        BCF     STATUS,RP0         ;  1-  
     BSF     T1CON,0         ;TMR1-ON
     BSF      INTCON,GIE        ; 
N_Metr2                             ;


       BTFSS    PORTA,RA0           ; 
       RETURN                     ;


       BTFSC   INTCON,INTF            ;
       GOTO    N_Metr3                 ;
       BTFSS   PIR1,TMR1IF            ;
       GOTO     N_Metr2                ;
       INCF    REG_D,F        ;
       BCF     PIR1,TMR1IF         ;
       GOTO     N_Metr2                ;
N_Metr3                             ;
       CALL   INIT__F              ;
     CALL  INDIK_Metr               ;
     CALL   Bin2LCD              ;   .. 
     CALL   IND_IMP              ;
     CALL   _uS              ;
        RETURN                     ;
;F=============================================
IND_IMP                           ;
        MOVF   LED5,0              ;
	    call	LEDdata            ;
        MOVF   LED4,0              ;
	    call	LEDdata            ;
        MOVF   LED3,0              ;
	    call	LEDdata            ;
        MOVF   LED2,0              ;
	    call	LEDdata            ;
        MOVF   LED1,0              ;
	    call	LEDdata            ;
                         MOVLW   .0        ;
;        MOVF   LED0,0              ;
	    call	LEDdata            ;
        RETURN                     ;
;******************************************************
INDIK_Metr                             ;
        MOVF    REG_D,W             ;
        MOVWF    TimerH             ;
        MOVF    TMR1H,W             ;
        MOVWF    TimerM             ;
        MOVF    TMR1L,W             ;
        MOVWF    TimerL             ;
        RETURN                     ;
;=============================================
; 
;=============================================
CNR_1                               ;
  CALL      INIT_1
     CALL    IND_CNR               ;
  CALL     P_CNR                ;
	movlw	b'10001010'	;   
	call	LEDcom		;
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _OFF               ;
   CALL   IN_UHF                ; 
CNR_2                               ;

BUTT_RA0
BUTT_RA1

      BTFSC    PORTA,RA2           ;
      GOTO    CNR_2              ;
    CALL     _T30mS            ;
      BTFSC    PORTA,RA2           ;
      GOTO    CNR_2              ;
	movlw	b'10001010'	;   
	call	LEDcom		;
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _ON               ;
  CALL   INIT_1                ;
CNR_3                               ;
      BTFSS    PORTA,RA2           ; 
      GOTO    CNR_3              ;
    CALL   INIT_F              ;  TMR0
CNR_4                               ;
      BTFSC    PORTA,RA2           ; 
      GOTO    CNR_4              ;
    CALL     _T30mS            ;
      BTFSC    PORTA,RA2           ;
      GOTO    CNR_4              ;
    CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
    CALL   Bin2LCD              ;
        BSF     STATUS,RP0         ;  2-  
        MOVLW   B'10000111'        ;  OPTION (=256),
        MOVWF   OPTION_REG         ; 
        BCF     STATUS,RP0         ;  1-  
        CLRF    INTCON             ;  TMR0
      CALL    IND_CNR               ;
	movlw	b'10001010'	;   
	call	LEDcom		;
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _OFF               ;
        CALL    _T2S               ;
        GOTO   CNR_2                 ;
;*********************************************
IND_CNR                           ;
	movlw	b'11000000'	;   
	call	LEDcom		;
	movlw	1Eh	           ;N
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
        MOVF   LED7,0              ;
	    call	LEDdata            ;
        MOVF   LED6,0              ;
	    call	LEDdata            ;
        MOVF   LED5,0              ;
	    call	LEDdata            ;
        MOVF   LED4,0              ;
	    call	LEDdata            ;
        MOVF   LED3,0              ;
	    call	LEDdata            ;
        MOVF   LED2,0              ;
	    call	LEDdata            ;
        MOVF   LED1,0              ;
 	    call	LEDdata            ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
       RETURN             ;
;*********************************************
P_CNR                           ;
	movlw	b'10000011'	;   
	call	LEDcom		;
	movlw	13h	                  ;C
	call	LEDdata
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	1Eh	                  ;N
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
	movlw	22h	                  ;R
	call	LEDdata
       RETURN             ;
;=============================================
;=============================================
;  
;=============================================
DELTA_1                               ;
       CALL     F_DEL               ;   
       CALL   IN_UHF                ; 
	movlw	b'10001100'	;   
	call	LEDcom		;
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _OFF               ;
DELTA_2                               ;

BUTT_RA0
BUTT_RA1

      BTFSC    PORTA,RA2           ;
      GOTO    DELTA_2              ;
    CALL     _T30mS            ;
      BTFSC    PORTA,RA2           ;
      GOTO    DELTA_2              ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
DELTA__2                               ;
      BTFSS    PORTA,RA2           ;
      GOTO    DELTA__2              ;
       CALL     F_DEL               ;   
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _ON               ;
    CALL   IN_UHF                ; 
      CALL   INIT_1                ;
      CALL    F_1S             ;  
      CALL   INIT__F                 ;  TMR0

    MOVF    TimerL,W             ;  
       MOVWF    REG_FL             ;
       MOVF    TimerM,W             ;
       MOVWF    REG_FM             ;
       MOVF    TimerH,W             ;
       MOVWF    REG_FH             ;
       MOVF    TimerHH,W             ;
       MOVWF    REG_FHH             ;

DELTA_3                               ;
      CALL   INIT_1                ;
      CALL    F_1S             ;
      CALL   INIT__F                 ;  TMR0

      BTFSC    PORTA,RA2           ;
      GOTO    DELTA__3              ;
    CALL     _T30mS            ;
      BTFSS    PORTA,RA2           ;
      GOTO    DEL_MAX              ;

DELTA__3                               ;
            BCF      REG_SL,2        ;
    CALL   SUB_F              ;
           BTFSC   TimerHH,7            ;
    CALL   INV_DEL              ;
           BTFSC   REG_SL,2            ;
        GOTO    DELTA_N              ;

DELTA_P                      ;
        MOVF   TimerH,W              ; 
        SUBWF    REG_dFH,W          ;   
        BTFSS   STATUS,C            ;
        GOTO   DELTA__P               ;
      BTFSS   STATUS,Z            ;
        GOTO   DELTA_5               ;
      MOVF   TimerM,W              ; 
        SUBWF    REG_dFM,W          ;   
        BTFSS   STATUS,C            ;
        GOTO   DELTA__P               ;
      BTFSS   STATUS,Z            ;
        GOTO   DELTA_5               ;
      MOVF   TimerL,W              ; 
        SUBWF    REG_dFL,W          ;   
        BTFSC   STATUS,C            ;
        GOTO   DELTA_5               ;

DELTA__P                      ;
        MOVF   TimerH,W              ;
        MOVWF    REG_dFH            ;
        MOVF   TimerM,W              ;
        MOVWF    REG_dFM            ;
        MOVF   TimerL,W              ;
        MOVWF    REG_dFL            ;
      GOTO   DELTA_5               ;

DELTA_N                      ;
        MOVF   TimerH,W              ; 
        SUBWF    REG__dFH,W          ;   
        BTFSS   STATUS,C            ;
        GOTO   DELTA__N               ;
      BTFSS   STATUS,Z            ;
        GOTO   DELTA_5               ;
      MOVF   TimerM,W              ; 
        SUBWF    REG__dFM,W          ;   
        BTFSS   STATUS,C            ;
        GOTO   DELTA__N               ;
      BTFSS   STATUS,Z            ;
        GOTO   DELTA_5               ;
      MOVF   TimerL,W              ; 
        SUBWF    REG__dFL,W          ;   
        BTFSC   STATUS,C            ;
        GOTO   DELTA_5               ;
DELTA__N                      ;
        MOVF   TimerH,W              ;
        MOVWF    REG__dFH            ;
        MOVF   TimerM,W              ;
        MOVWF    REG__dFM            ;
        MOVF   TimerL,W              ;
        MOVWF    REG__dFL            ;
DELTA_5                      ;
    CALL   Bin2LCD              ;
	movlw	b'11000000'	;   
	call	LEDcom		;
           BTFSS   REG_SL,2            ;
	movlw	0FBh	                  ;+
           BTFSC   REG_SL,2            ;
	movlw	0FDh	                  ;-
	call	LEDdata
       CALL   IND_DEL              ;
         CALL    _T1S               ;
       GOTO   DELTA_3                 ;
;OK=============================================
DEL_MAX                      ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
DEL__MAX                      ;
      BTFSS    PORTA,RA2           ;
      GOTO     DEL__MAX             ;
	movlw	b'10000000'	;   
	call	LEDcom		;
         CALL    F_MAX               ;
	movlw	0FBh	                  ;+
	call	LEDdata
      CLRF     TimerHH          ;
        MOVF   REG_dFH,W              ;
        MOVWF    TimerH            ;
        MOVF   REG_dFM,W              ;
        MOVWF    TimerM            ;
        MOVF   REG_dFL,W              ;
        MOVWF    TimerL            ;
    CALL   Bin2LCD              ;
       CALL   IND_DEL              ;
	movlw	b'11000000'	;   
	call	LEDcom		;
         CALL    F_MAX               ;
	movlw	0FDh	                  ;-
	call	LEDdata
      CLRF     TimerHH          ;
        MOVF   REG__dFH,W              ;
        MOVWF    TimerH            ;
        MOVF   REG__dFM,W              ;
        MOVWF    TimerM            ;
        MOVF   REG__dFL,W              ;
        MOVWF    TimerL            ;
    CALL   Bin2LCD              ;
        CALL   IND_DEL              ;
      CLRF     REG_dFL          ;
        CLRF     REG_dFM          ;
        CLRF     REG_dFH          ;
        CLRF     REG__dFL          ;
        CLRF     REG__dFM          ;
        CLRF     REG__dFH          ;
       GOTO   DELTA_2                 ;
;=============================================
SUB_F                    ;
      MOVF    REG_FL,W             ;
    	SUBWF	TimerL,F      	;
        MOVLW   B'00000001'        ;
        BTFSS   STATUS,C            ;
    	SUBWF	TimerM,F      	;
        BTFSS   STATUS,C            ;
     	SUBWF	TimerH,F      	;
        BTFSS   STATUS,C            ;
     	SUBWF	TimerHH,F      	;
      MOVF    REG_FM,W             ;
      	SUBWF	TimerM,F      	;
        MOVLW   B'00000001'        ;
        BTFSS   STATUS,C            ;
      	SUBWF	TimerH,F      	;
        BTFSS   STATUS,C            ;
     	SUBWF	TimerHH,F      	;
      MOVF    REG_FH,W             ;
      	SUBWF	TimerH,F      	;
        MOVLW   B'00000001'        ;
        BTFSS   STATUS,C            ;
      	SUBWF	TimerHH,F      	;
      MOVF    REG_FHH,W             ;
      	SUBWF	TimerHH,F      	;
       RETURN                     ;
;=============================================
INV_DEL                           ;
       BSF      REG_SL,2        ;
        COMF   TimerL,F              ;
       INCF    TimerL,F            ;
        COMF   TimerM,F              ;
        COMF   TimerH,F              ;
        COMF   TimerHH,F              ;
       RETURN             ;
;=============================================
IND_DEL                           ;
       BTFSC  R_IN,2            ;
     GOTO   IND_DEL1              ;
        MOVF   LED5,0              ;
	    call	LEDdata            ;
IND_DEL1                           ;
        MOVF   LED4,0              ;
	    call	LEDdata            ;
        MOVF   LED3,0              ;
	    call	LEDdata            ;
     BTFSC  R_IN,2            ;
     CALL   ZAP_Y              ;
        MOVF   LED2,0              ;
	    call	LEDdata            ;
        MOVF   LED1,0              ;
 	    call	LEDdata            ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
       BTFSS  R_IN,2            ;
     GOTO   IND_DEL2              ;
     CALL   MHZ_F              ;
       RETURN             ;
IND_DEL2                           ;
     CALL   HZ_F              ;
       RETURN             ;
;********************************************************
F_DEL                      ;
	movlw	b'10000000'	;   
	call	LEDcom		;
	movlw	0FBh	                  ;+
	call	LEDdata
	movlw	0FFh	                  ;/
	call	LEDdata
	movlw	0FDh	                  ;-
	call	LEDdata
F__DEL                      ;
	movlw	16h	              ;F
	call	LEDdata
	movlw	22h	                ;R
	call	LEDdata
	movlw	15h	               ;E
	call	LEDdata
	movlw	21h	                ;Q
	call	LEDdata
	movlw	25h	                ;U
	call	LEDdata
	movlw	15h	               ;E
	call	LEDdata
	movlw	1Eh	                 ;N
	call	LEDdata
	movlw	13h	               ;C
	call	LEDdata
	movlw	29h	                ;Y
	call	LEDdata
       RETURN             ;
;=============================================
;=============================================
; 
;=============================================
VHF_D                             ;
        BTFSC   R_IN,0            ;
        GOTO     F_IZM            ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
  CALL     F_DIV                ;
	movlw	0FDh	                  ;-
	call	LEDdata
    CALL     _ON                ;
VHF_D1                             ;
      BTFSS    PORTA,RA2           ;
      GOTO    VHF_D1           ;
       CALL    _T2S               ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;

        BSF     STATUS,RP0         ;
        BCF     TRISC,5         ;
        BCF     STATUS,RP0         ;
        BSF     PORTC,RC5         ;

   BCF   PORTC,RC0           ; 
   BCF   PORTC,RC1           ; 

VHF__D                             ;
      BTFSS    PORTA,RA2           ;
      GOTO    VHF__D              ;
	movlw	b'11001100'	;   
	call	LEDcom		;
   BTFSC  R_IN,2            ;
       GOTO   UHF_D                ;
       BTFSS  R_IN,1            ;
       GOTO    F_IZM             ;
       CALL   _VHF               ;
  CALL    LATCHES              ;
UST_H_V                               ;
      MOVF    R_VHF_L,W           ;
      MOVWF   TimerL             ;
      MOVF    R_VHF_H,W           ;
      MOVWF   TimerM             ;
	movlw	b'11000000'	;   . 
	call	LEDcom		;
    CALL    _LED               ;
  CALL    R__Counter              ;
      BTFSC    PORTA,1           ;
       CLRF   R_TL               ;
       BTFSS   R_TL,4            ;
       GOTO    UST_H_V2           ;
       CALL     _T30mS            ;
       GOTO    UST_H_V4           ;
UST_H_V2                               ;
                 CALL   VHF__D1               ;
       BTFSS    PORTA,RA2           ;
      GOTO    K_UST           ;
     BTFSS    PORTA,0           ;
       GOTO      UST_L_V           ;
     BTFSC    PORTA,1           ;
       GOTO    UST_H_V2           ;
       CALL     _T30mS            ;
     BTFSC    PORTA,1           ;
       GOTO    UST_H_V2                ;
UST_H_V3                               ;
       BTFSC   R_TL,4            ;
       GOTO    UST_H_V4            ;
       BTFSC   INTCON,2           ;
       CALL   _TS               ;
     BTFSS    PORTA,1           ;
       GOTO    UST_H_V3             ;
       CALL     _T30mS            ;
     BTFSS    PORTA,1           ;
       GOTO    UST_H_V3             ;
UST_H_V4                               ;
    MOVLW   .1        ;
       BTFSS   R_TL,4            ;
       GOTO    UST_H_V5           ;
       INCF    R_TH,F        ;
       MOVF   R_TH,W           ;
UST_H_V5                         ;
     ADDWF  	R_VHF_L,F      	;
      BTFSC  STATUS,C            ;
     INCF    R_VHF_H,F        ;
     MOVF   R_VHF_H,W 
       SUBLW   .63 
        BTFSC  STATUS,C            ;
       GOTO    UST_H_V               ;
       MOVLW   .0        ;
     MOVWF   R_VHF_H              ;
       MOVLW   .3        ;
     MOVWF   R_VHF_L              ;
      GOTO   UST_H_V              ;
K_UST                         ;
	movlw	b'00000001'       	; 
	call	LEDcom               ;
  CALL     F_DIV                ;
	movlw	0FDh	                  ;-
	call	LEDdata
     CALL    _OFF               ;
K_UST1                         ;
      BTFSS    PORTA,RA2           ;
      GOTO    K_UST1           ;
    CALL    _T2S               ;
        BSF     STATUS,RP0         ;
        BSF     TRISC,5         ;
        BCF     STATUS,RP0         ;
    GOTO    F_IZM             ;
; ***************************
UST_L_V                               ;
    BTFSC    PORTA,0           ;
     CLRF   R_TL               ;
     BTFSS   R_TL,4            ;
     GOTO    UST_L_V1           ;
     CALL     _T30mS            ;
     GOTO    UST_L_V3           ;
UST_L_V1                               ;
                      CALL   VHF__D1               ;
       BTFSS    PORTA,RA2           ;
       GOTO    K_UST           ;
     BTFSS    PORTA,1           ;
       GOTO      UST_H_V2           ;
     BTFSC    PORTA,0           ;
       GOTO      UST_L_V           ;
       CALL     _T30mS            ;
     BTFSC    PORTA,0           ;
       GOTO    UST_L_V                ;
UST_L_V2                               ;
     BTFSC   R_TL,4            ;
     GOTO    UST_L_V3             ;
     BTFSC   INTCON,2           ;
     CALL   _TS               ;
    BTFSS    PORTA,0          ;
       GOTO    UST_L_V2             ;
       CALL     _T30mS            ;
    BTFSS    PORTA,0           ;
       GOTO    UST_L_V2               ;
UST_L_V3                               ;
    MOVLW   .1        ;
       BTFSS   R_TL,4            ;
       GOTO    UST__L_V3           ;
       INCF    R_TH,F        ;
       MOVF   R_TH,W           ;
UST__L_V3                         ;
     SUBWF   R_VHF_L,F
        BTFSS  STATUS,C            ;
        DECF    R_VHF_H,F        ;
     MOVF   R_VHF_H,W 
       SUBLW   .64 
        BTFSS  STATUS,C            ;
       GOTO    UST_L__V3               ;
     MOVF   R_VHF_H,W 
       SUBLW   .0 
        BTFSS  STATUS,C            ;
       GOTO    UST_L_V4               ;
     MOVF   R_VHF_L,W 
       SUBLW   .2 
        BTFSS  STATUS,C            ;
       GOTO    UST_L_V4               ;
UST_L__V3                         ;
       MOVLW   B'11111111'        ;
       MOVWF   R_VHF_L         ;
       MOVLW   B'00111111'        ;
       MOVWF   R_VHF_H         ;
UST_L_V4                               ;
     MOVF    R_VHF_L,W           ;
     MOVWF   TimerL             ;
     MOVF    R_VHF_H,W           ;
     MOVWF   TimerM             ;
	movlw	b'11000000'	;   
	call	LEDcom		;
    CALL    _LED               ;   
  CALL    R__Counter              ;
       GOTO   UST_L_V              ;
;=============================================
;=============================================
UHF_D                             ;
       CALL   _UHF               ;
  CALL    LATCHES              ;
UST_H_U                               ;
     MOVF    R_UHF_L,W           ;
     MOVWF   TimerL             ;
     MOVF    R_UHF_H,W           ;
     MOVWF   TimerM             ;
	movlw	b'11000000'	;   
	call	LEDcom		;
    CALL    _LED               ;   
  CALL    N__Counter              ;
      BTFSC    PORTA,1           ;
       CLRF   R_TL               ;
       BTFSS   R_TL,4            ;
       GOTO    UST_H_U2           ;
       CALL     _T30mS            ;
       GOTO    UST_H_U4           ;
UST_H_U2                               ;
                     CALL   VHF__D1               ;
       BTFSS    PORTA,RA2           ;
     GOTO    K_UST           ;
     BTFSS    PORTA,0           ;
       GOTO      UST_L_U           ;
     BTFSC    PORTA,1           ;
       GOTO    UST_H_U2           ;
       CALL     _T30mS            ;
     BTFSC    PORTA,1           ;
       GOTO    UST_H_U2                ;
UST_H_U3                               ;
       BTFSC   R_TL,4            ;
       GOTO    UST_H_U4            ;
       BTFSC   INTCON,2           ;
       CALL   _TS               ;
      BTFSS    PORTA,1           ;
       GOTO    UST_H_U3             ;
       CALL     _T30mS            ;
      BTFSS    PORTA,1           ;
       GOTO    UST_H_U3               ;
UST_H_U4                               ;
    MOVLW   .1        ;
       BTFSS   R_TL,4            ;
       GOTO    UST_H_U5           ;
       INCF    R_TH,F        ;
       MOVF   R_TH,W           ;
UST_H_U5                         ;
     ADDWF  	R_UHF_L,F      	;
      BTFSC  STATUS,C            ;
     INCF    R_UHF_H,F        ;
     MOVF   R_UHF_H,W 
       SUBLW   .3 
        BTFSS  STATUS,C            ;
       GOTO    UST_H_U               ;
     MOVF   R_UHF_L,W 
       SUBLW   .231 
        BTFSS  STATUS,C            ;
       GOTO    UST_H_U               ;
       MOVLW   .3        ;
     MOVWF   R_UHF_H              ;
       MOVLW   .232        ;
     MOVWF   R_UHF_L              ;
      GOTO   UST_H_U              ;
; ***************************
UST_L_U                               ;
    BTFSC    PORTA,0           ;
     CLRF   R_TL               ;
     BTFSS   R_TL,4            ;
     GOTO    UST_L_U1           ;
     CALL     _T30mS            ;
     GOTO    UST_L_U3           ;
UST_L_U1                               ;
                CALL   VHF__D1               ;
       BTFSS    PORTA,RA2           ;
     GOTO    K_UST           ;
     BTFSS    PORTA,1           ;
       GOTO      UST_H_U2           ;
     BTFSC    PORTA,0           ;
       GOTO      UST_L_U           ;
       CALL     _T30mS            ;
     BTFSC    PORTA,0           ;
       GOTO    UST_L_U                ;
UST_L_U2                               ;
     BTFSC   R_TL,4            ;
     GOTO    UST_L_U3             ;
     BTFSC   INTCON,2           ;
     CALL   _TS               ;
    BTFSS    PORTA,0          ;
       GOTO    UST_L_U2             ;
       CALL     _T30mS            ;
     BTFSS    PORTA,0           ;
       GOTO    UST_L_U2               ;
UST_L_U3                               ;
    MOVLW   .1        ;
       BTFSS   R_TL,4            ;
       GOTO    UST__L_U3           ;
       INCF    R_TH,F        ;
       MOVF   R_TH,W           ;
UST__L_U3                         ;
     SUBWF   R_UHF_L,F
        BTFSS  STATUS,C            ;
        DECF    R_UHF_H,F        ;
     MOVF   R_UHF_H,W 
       SUBLW   .3 
        BTFSS  STATUS,C            ;
       GOTO    UST_L_U4               ;
     MOVF   R_UHF_L,W 
       SUBLW   .231 
        BTFSS  STATUS,C            ;
       GOTO    UST_L_U4               ;
       MOVLW   B'11111111'        ;
       MOVWF   R_UHF_L         ;
       MOVLW   B'11111111'        ;
       MOVWF   R_UHF_H         ;
UST_L_U4                               ;
     MOVF    R_UHF_L,W           ;
     MOVWF   TimerL             ;
     MOVF    R_UHF_H,W           ;
     MOVWF   TimerM             ;
	movlw	b'11000000'	;   
	call	LEDcom		;
    CALL    _LED               ;   
  CALL    N__Counter              ;
       GOTO   UST_L_U              ;
;**********************************************************
_TS                             ; 
       BCF   INTCON,2             ;
       INCF  R_TL,1              ;
       CLRF   R_TH               ;
       RETURN                     ;
;**********************************************************
VHF__D1                             ;
       CALL   F__M_r              ;   -F=

     CALL   INIT_1                ;
     CALL    F_100mS              ;
       CALL   INIT__F              ;
     CALL   Bin2LCD              ;

VHF__D2                             ;
        MOVF   LED5,0              ;
	    call	LEDdata            ;
        MOVF   LED4,0              ;
	    call	LEDdata            ;
        MOVF   LED3,0              ;
	    call	LEDdata            ;
        MOVF   LED2,0              ;
	    call	LEDdata            ;
     CALL   ZAP_Y              ;
        MOVF   LED1,0              ;
 	   call	LEDdata            ;
        MOVF   LED0,0              ;
	    call	LEDdata            ;
   	movlw	3Bh	           ;k
	call	LEDdata
     CALL   HZ_F              ;
       RETURN             ;
;**********************************************************
;   ************************************************
_LED                               ;
	movlw	1Bh	           ;K
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
  CALL    ZAP_K             ;
    CLRF     TimerH          
    CLRF     TimerHH      
      CALL   Bin2LCD        ;    -
     MOVF   LED4,W              ;
 	call	LEDdata
     MOVF   LED3,W              ;
 	call	LEDdata
     MOVF   LED2,W              ;
 	call	LEDdata
     MOVF   LED1,W              ;
	call	LEDdata
     MOVF   LED0,W              ;
	call	LEDdata
       RETURN                     ;
;=============================================
ZAP_K                               ;
     MOVLW   .1        ;
     MOVWF   R_EEADR             ;
     MOVF    R_VHF_L,W           ;
     MOVWF   R_EEDATA             ;
     CALL    _ZAP            ;
     MOVLW   .2        ;
     MOVWF   R_EEADR             ;
     MOVF    R_VHF_H,W           ;
     MOVWF   R_EEDATA             ;
     CALL    _ZAP            ;
    MOVLW   .3        ;
     MOVWF   R_EEADR             ;
     MOVF    R_UHF_L,W           ;
     MOVWF   R_EEDATA             ;
     CALL    _ZAP            ;
     MOVLW   .4        ;
     MOVWF   R_EEADR             ;
     MOVF    R_UHF_H,W           ;
     MOVWF   R_EEDATA             ;
    CALL    _ZAP            ;
       RETURN                     ;
;=============================================
READ_K                               ;
     MOVLW   .1        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_VHF_L             ;
     MOVLW   .2        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_VHF_H             ;
    MOVLW   .3        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_UHF_L             ;
     MOVLW   .4        ;
     MOVWF   R_EEADR             ;
     CALL    _READ            ;
     MOVF    R_EEDATA,W           ;
     MOVWF   R_UHF_H             ;
       RETURN                  
;SPI=============================================
R__Counter                   ;K=3-16383
     MOVF    R_VHF_H,W           ;
     MOVWF   TEMP_H             ;
     MOVF    R_VHF_L,W           ;
     MOVWF   TEMP_L             ;
;   BCF     PORTC,RC4          ;
                           BCF     PORTB,RB3          ;
        NOP
        CALL    DATA_0              ;
        CALL    DATA_0              ;Test
        CALL    DATA_0              ;Test
        CALL    DATA_0              ;Test
        CALL    DATA_0              ;Test
   CALL     RCounter            ;
     CALL     RCounter            ;
     CALL     RCounter            ;
     CALL     RCounter            ;
     CALL     RCounter            ;
     CALL     RCounter            ;
   CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
     CALL     RRCounter            ;
   CALL    DATA_0              ;R Counter
      CALL    DATA_0              ;R Counter
        NOP
;   BSF     PORTC,RC4          ;
                           BSF     PORTB,RB3          ;
       BSF     PORTB,RB2          ;
       BSF     PORTB,RB1          ;
     MOVF    TEMP_H,W           ;
     MOVWF   R_VHF_H             ;
     MOVF    TEMP_L,W           ;
     MOVWF   R_VHF_L             ;
       RETURN                     ;
RCounter                   ;
    BTFSS   R_VHF_H,5            ;
     CALL     DATA_0            ;
     BTFSC   R_VHF_H,5            ;
     CALL     DATA_1            ;
   RLF    R_VHF_H,F            ;
       RETURN                     ;
RRCounter                   ;
    BTFSS   R_VHF_L,7            ;
     CALL     DATA_0            ;
     BTFSC   R_VHF_L,7            ;
     CALL     DATA_1            ;
   RLF    R_VHF_L,F            ;
       RETURN                     ;
;SPI=============================================
N__Counter                   ;K=1000-65535
     MOVF    R_UHF_H,W           ;
     MOVWF   TEMP_H             ;
     MOVF    R_UHF_L,W           ;
     MOVWF   TEMP_L             ;
;   BCF     PORTC,RC4          ;
                           BCF     PORTB,RB3          ;
        NOP
     CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
   CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
     CALL     NCounter            ;
   CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
     CALL     NNCounter            ;
   CALL    DATA_0              ;N Counter
      CALL    DATA_1              ;N Counter
        NOP
;   BSF     PORTC,RC4          ;
                           BSF     PORTB,RB3          ;
       BSF     PORTB,RB2          ;
       BSF     PORTB,RB1          ;
     MOVF    TEMP_H,W           ;
     MOVWF   R_UHF_H             ;
     MOVF    TEMP_L,W           ;
     MOVWF   R_UHF_L             ;
       RETURN                     ;
NCounter                   ;
    BTFSS   R_UHF_H,7            ;
     CALL     DATA_0            ;
     BTFSC   R_UHF_H,7            ;
     CALL     DATA_1            ;
   RLF    R_UHF_H,F            ;
       RETURN                     ;
NNCounter                   ;
    BTFSS   R_UHF_L,7            ;
     CALL     DATA_0            ;
     BTFSC   R_UHF_L,7            ;
     CALL     DATA_1            ;
   RLF    R_UHF_L,F            ;
       RETURN                     ;
;SPI=============================================
N_Counter                   ;K=1000  (UHF)
;   BCF     PORTC,RC4          ;
                           BCF     PORTB,RB3          ;
        NOP
       CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_0              ;
        CALL    DATA_1              ;/16
        CALL    DATA_1              ;/8
        CALL    DATA_1              ;/4
        CALL    DATA_1              ;/2
        CALL    DATA_1              ;/1
      CALL    DATA_0             ;   LMX2306
      CALL    DATA_1             ;   LMX2306   /8
      CALL    DATA_0              ;
      CALL    DATA_0              ;
      CALL    DATA_0              ;
     CALL    DATA_0              ;N Counter
      CALL    DATA_1              ;N Counter
        NOP
;   BSF     PORTC,RC4          ;
                           BSF     PORTB,RB3          ;
       BSF     PORTB,RB2          ;
       BSF     PORTB,RB1          ;
       RETURN                     ;
;SPI=============================================
LATCHES                   ;
;   BCF     PORTC,RC4          ;
                           BCF     PORTB,RB3          ;
      NOP
       CALL    DATA_0              ;
        CALL    DATA_0              ;POWER DOWN x
        CALL    DATA_0              ;Test Modes 0 ( -0)
        CALL    DATA_0              ;Test Modes 0 ( -0)
        CALL    DATA_0              ;Test Modes 0 ( -0)
        CALL    DATA_0              ;FastLock Timeout Counter
        CALL    DATA_0              ;FastLock Timeout Counter
        CALL    DATA_0              ;FastLock Timeout Counter
        CALL    DATA_0              ;FastLock Timeout Counter
        CALL    DATA_0              ;Timeout Counter Enable
        CALL    DATA_0              ;FastLock
        CALL    DATA_0              ;FastLock Enable
        CALL    DATA_0              ;Charge Pump TRI-STATE 0
        CALL    DATA_0              ;Phase Detector Polarity
     BTFSS  R_IN,2            ;
     GOTO   LATCHES1                ;
       CALL    DATA_0              ;N Divider Output (fp)(  N-)
       CALL    DATA_1              ;N Divider Output (fp)(  N-)
       CALL    DATA_0              ;N Divider Output (fp)(  N-)
     GOTO   LATCHES2                ;
LATCHES1                   ;
       CALL    DATA_1              ;R Divider Output (fp)(  R-)
       CALL    DATA_0              ;R Divider Output (fp)(  R-)
       CALL    DATA_0              ;R Divider Output (fp)(  R-)
LATCHES2                   ;
       BTFSC  R_IN,0            ;
  CALL    DATA_1              ;POWER - OF
       BTFSS  R_IN,0            ;
  CALL    DATA_0              ;POWER - ON
        CALL    DATA_0              ;( )
       CALL    DATA_1              ;LATCHES
        CALL    DATA_0              ;LATCHES
        NOP
;   BSF     PORTC,RC4          ;
                           BSF     PORTB,RB3          ;
       BSF     PORTB,RB2          ;
       BSF     PORTB,RB1          ;
       RETURN                     ;
;********************************************************
DATA_0
       BCF     PORTB,RB2          ;
        NOP                ;
       BSF     PORTB,RB1          ;
        NOP
       BCF     PORTB,RB1          ;
        NOP
       BCF     PORTB,RB2          ;
       RETURN                     ;
;********************************************************
DATA_1
       BSF     PORTB,RB2          ;
        NOP
       BSF     PORTB,RB1          ;
        NOP
       BCF     PORTB,RB1          ;
        NOP
       BCF     PORTB,RB2          ;
       RETURN                     ;
;*********************************************
F_DIV                           ;
	movlw	b'10000100'	;   
	call	LEDcom		;
	movlw	14h	                  ;D
	call	LEDdata
	movlw	19h	                  ;I
	call	LEDdata
	movlw	26h	                ;V
	call	LEDdata
	movlw	19h	                  ;I
	call	LEDdata
	movlw	14h	                  ;D
	call	LEDdata
	movlw	15h	                  ;E
	call	LEDdata
	movlw	22h	                  ;R
	call	LEDdata
       RETURN             ;
;********************************************************
;=============================================
;    -
;
;=============================================
Bin2LCD                     ;
    	movf	TimerHH,w
    	movwf	IFHH
    	movf	TimerH,w
    	movwf	IFH
    	movf	TimerM,w
    	movwf	IFM
    	movf	TimerL,w
    	movwf	IFL
    	bcf        STATUS,0
        movlw      .32
        movwf      Count
    	clrf       LED4
        clrf       LED3
        clrf       LED2
        clrf       LED1
        clrf       LED0
loop32
        rlf        IFL,f
        rlf        IFM,f
        rlf        IFH,f
     rlf        IFHH,f
        rlf        LED0,f
        rlf        LED1,f
        rlf        LED2,f
        rlf        LED3,f
        rlf        LED4,f
        decfsz     Count,f
        goto       adjDEC
        movfw      LED4
        andlw      0Fh
        movwf      LED8
        swapf      LED3,w
        andlw      0Fh
        movwf      LED7
        movfw      LED3
        andlw      0Fh
        movwf      LED6
        swapf      LED2,w
        andlw      0Fh
        movwf      LED5
        movfw      LED2
        andlw      0Fh
        movwf      LED4
        swapf      LED1,w
        andlw      0Fh
        movwf      LED3
        movfw      LED1
        andlw      0Fh
        movwf      LED2
        swapf      LED0,w
        andlw      0Fh
        movwf      LED1
        movfw      LED0
        andlw      0Fh
        movwf      LED0           ;
        return
adjDEC                        ;
        movlw      LED0   ;
        movwf      FSR
        call       adjBCD
        movlw      LED1
        movwf      FSR
     	call       adjBCD
        movlw      LED2
        movwf      FSR
        call       adjBCD
        movlw      LED3
        movwf      FSR
        call       adjBCD
    	movlw      LED4
        movwf      FSR
        call       adjBCD
        goto       loop32
adjBCD
        movlw      3
        addwf      0,w
        movwf      Count2
        btfsc      Count2,3
        movwf      0
        movlw      30
        addwf      0,w
        movwf      Count2
        btfsc      Count2,7
        movwf      0
        retlw      0
;********************************************************
;  
;********************************************************
INIT_GKI                           ; . 
      CALL    _T30mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
      CALL    _T30mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
      CALL    _T2mS               ;
	movlw	b'00110000'	;  
	call	LEDcom        ;
	movlw	b'00000010'	;  (  )	
	call	LEDcom        ;
	movlw	b'00000001'	; 
	call	LEDcom
	movlw	b'00001100'	   ; , ,.)
	call	LEDcom
	movlw	b'00101000'	    ;  (4-)
	call	LEDcom
        RETURN                     ;
;   .=============================================
LEDdata	               ;
   	bsf	PORTC,RC6	;1   RS 
	movwf	LEDtemp		;   
	addlw	30h		;    
          CALL   LED_LCD              ;    
	call	ST
	movf	LEDtemp,w
	addlw	30h
	movwf	Temp
	swapf	Temp,w       ;
          CALL   LED_LCD              ;    
	call	ST
	movf	LEDtemp,w
    return
;   .=============================================
LEDcom	               ;		
   	bcf	PORTC,RC6	;0   RS 
	movwf	LEDtemp      ;
      CALL   LED_LCD              ;    
	call	ST
	movf 	LEDtemp,w
	movwf	Temp
	swapf	Temp,w 		; 
      CALL   LED_LCD              ;    
	call	ST            ;
    CALL     _T2mS             ;
    return
; -.==============OK===============================
ST                               ;
	bsf	  PORTC,RC7 ;1   E 
	nop			;
	nop			;
	bcf	    PORTC,RC7      ;0   E 
      	movlw	.25		;
	movwf	Temp
_ST                                  ;
	decfsz  Temp,f
	goto   _ST 
    return
;  .=============================================
LED_LCD	               ;		
    MOVWF    W_TEMP             ;
       BTFSS  W_TEMP,4            ;
       BCF   PORTB,RB4           ;
       BTFSC  W_TEMP,4            ;
       BSF   PORTB,RB4           ;
       BTFSS  W_TEMP,5            ;
       BCF   PORTB,RB5           ;
       BTFSC  W_TEMP,5            ;
       BSF   PORTB,RB5           ;
       BTFSS  W_TEMP,6            ;
       BCF   PORTB,RB6           ;
       BTFSC  W_TEMP,6            ;
       BSF   PORTB,RB6           ;
       BTFSS  W_TEMP,7            ;
       BCF   PORTB,RB7           ;
       BTFSC  W_TEMP,7            ;
       BSF   PORTB,RB7           ;
    return
;**********************************************************
;.
;*************************************************************
F_10S                               ; 10
    CLRF    R_TIMER              ;
       MOVLW   B'00110101'        ;K=8
       MOVWF   T1CON             ;
       BCF   PIR1,0           ;
       CALL   INIT_F              ;
F_10S1                               
       BTFSS   PIR1,0            ;
       GOTO   F_10S1                  ;
       BCF   PIR1,0           ;
   INCF  R_TIMER,F              ;
      BTFSS    PORTA,RA0           ; 
      RETURN                     ;
      BTFSS    PORTA,RA1           ;
      RETURN                     ;
      BTFSS    PORTA,RA2           ;
      RETURN                     ;
    MOVLW   B'00010011'        ;
      	SUBWF	R_TIMER,W      	;
        BTFSS   STATUS,Z            ;
        GOTO     F_10S1                ;
     CLRF    R_TIMER              ;
       MOVLW   B'11101101'        ;
       MOVWF   TMR1H             ;
       MOVLW   B'01100001'        ;
       MOVWF   TMR1L             ;
     BCF   PIR1,0           ;
F_10S2                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_10S2                  ;
    CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
       RETURN                     ;
;=============================================
F_1S                               ; 1
    CALL   INIT_1                ;
       MOVLW   B'00110100'        ;K=8 ()
       MOVWF   T1CON             ;
       BCF   PIR1,0           ;
       CALL   INIT_F              ;
    BSF   T1CON,0           ; 
F_1S1                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_1S1                  ;
       BTFSS    PORTA,RA0           ; 
       RETURN                     ;
       BTFSS    PORTA,RA1           ;
       RETURN                     ;
     BTFSS    PORTA,RA2           ;
       RETURN                     ;
       MOVLW   B'00010111'        ;
       MOVWF   TMR1H             ;
               MOVLW   B'10111100'        ;B'10111001'
       MOVWF   TMR1L             ;
     BCF   PIR1,0           ;
F_1S2                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_1S2                  ;
   BCF   T1CON,0           ; 
      CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
       RETURN                     ;
;=============================================
F_100mS                               ; 100m
    CALL   INIT_1                ;
       MOVLW   B'00000100'        ;K=1 ()
       MOVWF   T1CON             ;
       BCF   PIR1,0           ;
       CALL   INIT_F              ;
   BSF   T1CON,0           ; 
F_100mS1                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_100mS1                  ;
       MOVLW   B'01111001'        ;
       MOVWF   TMR1H             ;
       MOVLW   B'01111000'        ;B'01100110'
       MOVWF   TMR1L             ;
     BCF   PIR1,0           ;
F_100mS2                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_100mS2                  ;
    BCF   T1CON,0           ; 
      CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
       RETURN                     ;
;=============================================
F_10mS                               ; 10m
       MOVLW   B'00000101'        ;K=1 ()
       MOVWF   T1CON             ;
      MOVLW   B'11011000'        ;
       MOVWF   TMR1H             ;
       MOVLW   B'11110001'        ;
      MOVWF   TMR1L             ;
       BCF   PIR1,0           ;
       CALL   INIT_F              ;
F_10mS1                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_10mS1                  ;
    CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
       RETURN                     ;
;=============================================
F_1mS                               ; 1m
       MOVLW   B'00000101'        ;K=1 ()
       MOVWF   T1CON             ;
      MOVLW   B'11111100'        ;
       MOVWF   TMR1H             ;
       MOVLW   B'00010000'        ;
      MOVWF   TMR1L             ;
       BCF   PIR1,0           ;
       CALL   INIT_F              ;
F_1mS1                               ;
       BTFSS   PIR1,0            ;
       GOTO   F_1mS1                  ;
    CLRF   R_Cont               ;
    BCF     INTCON,7         ; 
       MOVF    TMR0,W             ;
       MOVWF    TimerM             ;
    CALL   _Cont                 ;
       MOVF    R_Cont,W             ;
       MOVWF    TimerL             ;
       RETURN                     ;
;=============================================
_Cont                              ;
    BSF     PORTC,RC2         ;
     BSF     PORTC,RC3         ;
       DECF  R_Cont,F              ;
     BCF     PORTC,RC3         ;
    MOVF    TimerM,W             ;
   	SUBWF	TMR0,W      	;
       BTFSC   STATUS,Z            ;
       GOTO    _Cont               ;
    BCF     PORTC,RC2         ;
       RETURN                     ;
;=============================================
;OK=============================================
_T2mS                             ;  05ms
       CLRF    TMR0               ;
T2mS                              ;
       BTFSS   TMR0,3             ;
       GOTO    T2mS               ;
       CLRF    TMR0               ;
       RETURN                     ;
;**************************************************************
_T30mS                             ;  30ms
       CLRF    R_T               ;
       CLRF    R_TIMER               ;
T30mS                              ;
       INCF    R_T,F            ;
       BTFSS   STATUS,Z             ;
       GOTO    T30mS               ;
       INCF    R_TIMER,F            ;
       BTFSS   R_TIMER,5             ;
       GOTO    T30mS               ;
       CLRF    R_T               ;
       CLRF    R_TIMER               ;
       RETURN                     ;
;OK**********************************************************
_T1S                              ;  1
       CLRF   R_TIMER               ;
T1S                               ;
       BTFSS    PORTA,RA0           ; 
       RETURN                     ;
       BTFSS    PORTA,RA1           ;
       RETURN                     ;
       BTFSS    PORTA,RA2           ;
       RETURN                     ;
       BTFSS   INTCON,2           ;
       GOTO    T1S                ;
       BCF   INTCON,2             ;
       INCF  R_TIMER,1              ;
      BTFSS   R_TIMER,4            ;
       GOTO   T1S                 ;
       CLRF   R_TIMER               ;
       RETURN                     ;
;OK**********************************************************
_T2S                              ;  2
       CLRF    R_TIMER              ;
T2S                               ;
       BTFSS   INTCON,2           ;
       GOTO    T2S                ;
       BCF   INTCON,2             ;
       INCF  R_TIMER,F              ;
   BTFSS   R_TIMER,4            ;5
       GOTO   T2S                 ;
       CLRF  R_TIMER                ;
       RETURN                     ;
;OK**********************************************************
__T                              ;  
       BCF   INTCON,2             ;
       INCF  R_TIMER,F              ;
       RETURN                     ;
;*************************OK*************************************
AD_OFF                      ;
     CLRF   ADCON0               ;
     movlw   B'00000111'       ;
     bsf     STATUS,RP0       ;
     movwf   ADCON1           ;
     bcf     STATUS,RP0       ;
     RETURN                      ;
;***************************************************************
;   -TTL*********************************************
_TTL                        ;
	movlw	24h	                  ;T
	call	LEDdata
	movlw	24h	                  ;T
	call	LEDdata
	movlw	1Ch	              ;L
	call	LEDdata
    RETURN                     ;
;   -VHF*********************************************
_VHF                        ;
	movlw	26h	                ;V
	call	LEDdata
	movlw	18h	              ;H
	call	LEDdata
	movlw	16h	              ;F
	call	LEDdata
    RETURN                     ;
;   -UHF1*********************************************
_UHF                        ;
	movlw	25h	                ;U
	call	LEDdata
	movlw	18h	              ;H
	call	LEDdata
	movlw	16h	              ;F
	call	LEDdata
    RETURN                     ;
;   -F=*******************************
F__M_r                        ;
	movlw	b'10000000'	;   
	call	LEDcom		;
	movlw	16h	           ;F
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
    RETURN                     ;
;   -Fmax=*******************************
F_MAX                       ;
	movlw	34h	           ;d
	call	LEDdata    ;
	movlw	16h	           ;F
	call	LEDdata
	movlw	3Dh	           ;m
	call	LEDdata
	movlw	31h	           ;a
	call	LEDdata
	movlw	48h	           ;x
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
    RETURN                     ;
;   -uS*************************************
_uS                        ;
	movlw	45h	           ;u
	call	LEDdata
   	movlw	43h	             ;   s
	call	LEDdata
    RETURN                     ;
;   -ON*******************************
_ON                       ;
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	1Eh	                  ;N
	call	LEDdata
	movlw	0F0h	                  ;
	call	LEDdata
    RETURN                     ;
;   -OFF*******************************
_OFF                           ;
	movlw	1Fh	                  ;O
	call	LEDdata
	movlw	16h	                  ;F
	call	LEDdata
	movlw	16h	                  ;F
	call	LEDdata
       RETURN             ;
;********************************************************
P_Metr                               ;
	movlw	b'11000000'	;   
	call	LEDcom		;
   	movlw	18h	             ;   H
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
       RETURN             ;
;********************************************************
N_Metr                               ;
	movlw	b'11000000'	;   
	call	LEDcom		;
   	movlw	1Ch	              ;L
	call	LEDdata
	movlw	0Dh	           ;=
	call	LEDdata
       RETURN             ;
;=============================================
MHZ_F                        ;
	movlw	1Dh	           ;M
	call	LEDdata
HZ_F                        ;
	movlw	18h	             ;   H
	call	LEDdata
   	movlw	4Ah	           ;   z
	call	LEDdata       ;
       RETURN                     ;
;********************************************************
ZAP_Y                      ;
    	movlw	1FCh	           ;,
    	call	LEDdata             ;
        RETURN                     ;
;=============================================
;=============================================
INIT_F                              ;
        BSF     STATUS,RP0         ;  2-  
      MOVLW   B'10100111'        ;   TOCKI,=256
        MOVWF   OPTION_REG         ;
        BCF     STATUS,RP0         ;  1-  
    	MOVLW   B'10100000'        ;  TMR0
        MOVWF   INTCON         ;
        CLRF   TMR0              ;
        RETURN                     ;
;=============================================
INIT__F                              ;
        BSF     STATUS,RP0         ;  2-  
        MOVLW   B'10000111'        ;  OPTION (=256),
        MOVWF   OPTION_REG         ; 
      BCF   PIE1,0           ; 
        BCF     STATUS,RP0         ;  1-  
        CLRF    INTCON             ;  TMR0
        RETURN                     ;
;*********************************************************
;   
;*********************************************************
_ZAP                                ;
     MOVF    R_EEADR,W           ;
       BSF      STATUS,RP1         ;  2
       BCF      STATUS,RP0         ;
       MOVWF     EEADR             ;
       BCF      STATUS,RP1         ;  0
     MOVF      R_EEDATA,W           ; 
       BSF      STATUS,RP1         ;  2
       MOVWF     EEDATA            ;
       BSF      STATUS,RP1         ;  3
       BSF      STATUS,RP0         ;
       BTFSC    EECON1,WR          ;
       GOTO     $-1                ;
       BCF      EECON1,EEPGD          ;
       BCF      INTCON,GIE          ;
       BSF      EECON1,WREN        ; 
       MOVLW    055H               ;
       MOVWF    EECON2             ; 055H
       MOVLW    0AAh               ;
       MOVWF    EECON2             ; 0AAh 
       BSF      EECON1,WR          ;  WR,  
       BTFSC    EECON1,WR          ;
       GOTO     $-1                ;
       BCF      EECON1,WREN        ;
       BCF      STATUS,RP0         ;  0
       BCF      STATUS,RP1         ;
       RETURN                      ;  
;***************************************************************
_READ                              ; EEPROM
     MOVF    R_EEADR,W           ;
       BCF      STATUS,RP0         ;
       BSF      STATUS,RP1         ;  2
       MOVWF   EEADR               ;
       BSF      STATUS,RP0         ;  3
       BCF      EECON1,EEPGD          ;
       BSF     EECON1,RD           ;
       BCF      STATUS,RP0         ;  2
       MOVF    EEDATA,W            ;
       BCF      STATUS,RP1         ;  0
     MOVWF    R_EEDATA              ;
       RETURN                      ;  
;**************************************************************
;***************************************************************
INIT                           ;
      CLRF     REG_FL          ;
        CLRF     REG_FM          ;
        CLRF     REG_FH          ;
        CLRF     REG_FHH          ;
      CLRF     REG__FL          ;
        CLRF     REG__FM          ;
      CLRF     REG_dFL          ;
        CLRF     REG_dFM          ;
        CLRF     REG_dFH          ;
        CLRF     REG__dFL          ;
        CLRF     REG__dFM          ;
        CLRF     REG__dFH          ;
      CLRF     R_VHF_L 
        CLRF     R_VHF_H  
        CLRF     R_UHF_L  
        CLRF     R_UHF_H

       CLRF   R_RANG               ;
       CLRF   R_IN               ;
       BSF    R_IN,0          ;
       BSF    R_RANG,0          ;

 INIT_1                           ;

        CLRF    PIR1           ;
        CLRF   TMR0              ;
      CLRF   TMR1L             ;
      CLRF   TMR1H             ;
        CLRF     TEMP_L          ;
        CLRF     TEMP_M          ;
        CLRF     TEMP_H          ;
        CLRF     TEMP_HH          ;
      CLRF     TimerL          ;
        CLRF     TimerM          ;
        CLRF     TimerH          ;
        CLRF     TimerHH          ;
        CLRF     IFL           ;
        CLRF     IFM           ;
        CLRF     IFH           ;
        CLRF     IFHH           ;
        CLRF     LED0          ;
        CLRF     LED1          ;
        CLRF     LED2          ;
        CLRF     LED3          ;
        CLRF     LED4          ;
        CLRF     LED5          ;
        CLRF     LED6          ;
        CLRF     LED7          ;
        CLRF     LED8          ;
        CLRF    Count           ;
        CLRF   Count2            ;
        CLRF   R_TIMER                ; 
                CLRF      R_Cont       ;
        RETURN                     ;
; ***************************************************
 END                              ;  .
; *****************************************************
















